import java.awt.*;
import java.lang.*;
import java.io.*;

	class Estoc2Gui extends Frame {
		TextField a1,a2,a3;
		Button c1,c2,c3;
		Label l1,l2,l3;
		Estoc2Calculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		float a = 0.8f;
		int i = 100;
		int max = 100;

		Estoc2Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(a));
			a2 = new TextField(Integer.toString(i));
			a3 = new TextField(Integer.toString(max));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Parametre a");
			l2 = new Label("Nombre inicial");
			l3 = new Label("Nombre de passos");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1;
			int m;

			f1 = Float.valueOf(a1.getText());
			a = f1.floatValue();
			i = Integer.parseInt(a2.getText());
			max = Integer.parseInt(a3.getText());
			calcul = new Estoc2Calculs(a,i,max);
			if(plot) {
				System.out.println("plot '-' with points");
				for(m=0;m<max;m++)
					System.out.println(Integer.toString(m) + " " + Double.toString(calcul.traj[m]));
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' with points \n");
						}
						for(m=0;m<max;m++) {
							linia=Integer.toString(m) + " " + Double.toString(calcul.traj[m]) + "\n";
							sortida.write(linia);
						}
						if(eps) {
							sortida.write("e \n");
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Estoc2DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Estoc2DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Estoc2DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Estoc2DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Estoc2 {

	public static void main(String args[]) {
		Estoc2Gui estoc2 = null;		// Declaraci d'instncies.

		estoc2 = new Estoc2Gui("Estoc2");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				estoc2.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				estoc2.eps = true;
		}
		estoc2.init();
		estoc2.show();
	}
}

